org.mozilla.javascript.ast

## Class ElementGet

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.ElementGet

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class ElementGet
    extends AstNode

AST node for an indexed property reference, such as `foo['bar']` or `foo[2]`. This is sometimes called an "element-get" operation, hence the name of the node.

Node type is `Token.GETELEM`.

The node bounds extend from the beginning position of the target through the closing right-bracket. In the presence of a syntax error, the right bracket position is -1, and the node ends at the end of the element expression.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

`Node.NodeIterator`

### Field Summary

### Fields inherited from class org.mozilla.javascript.ast.AstNode

`length, parent, position`

### Fields inherited from class org.mozilla.javascript.Node

`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

### Constructor Summary

Constructors
Constructor and Description
`ElementGet()`
`ElementGet(AstNode target, AstNode element)`
`ElementGet(int pos)`
`ElementGet(int pos, int len)`

### Method Summary

Methods
`AstNode` `getElement()` Returns the element being accessed
`int` `getLb()` Returns left bracket position
`int` `getRb()` Returns right bracket position, -1 if missing
`AstNode` `getTarget()` Returns the object on which the element is being fetched.
`void` `setElement(AstNode element)` Sets the element being accessed, and sets its parent to this node.
`void` `setLb(int lb)` Sets left bracket position
`void` `setParens(int lb, int rb)`
`void` `setRb(int rb)` Sets right bracket position, -1 if not present
`void` `setTarget(AstNode target)` Sets target object, and sets its parent to this node.
`java.lang.String` `toSource(int depth)` Emits source code for this node.
`void` `visit(NodeVisitor v)` Visits this node, the target, and the index expression.

### Methods inherited from class org.mozilla.javascript.ast.AstNode

`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

### Methods inherited from class org.mozilla.javascript.Node

`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setDouble, setJsDocNode, setLineno, setScope, setString, setType, toString, toStringTree`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ElementGet

    public ElementGet()

#### ElementGet

    public ElementGet(int pos)

#### ElementGet

    public ElementGet(int pos,
              int len)

#### ElementGet

    public ElementGet(AstNode target,
              AstNode element)

### Method Detail

#### getTarget

    public AstNode getTarget()

Returns the object on which the element is being fetched.

#### setTarget

    public void setTarget(AstNode target)

Sets target object, and sets its parent to this node.

Parameters:
  `target` - expression evaluating to the object upon which to do the element lookup
Throws:
  `java.lang.IllegalArgumentException` - if target is `null`

#### getElement

    public AstNode getElement()

Returns the element being accessed

#### setElement

    public void setElement(AstNode element)

Sets the element being accessed, and sets its parent to this node.

Throws:
  `java.lang.IllegalArgumentException` - if element is `null`

#### getLb

    public int getLb()

Returns left bracket position

#### setLb

    public void setLb(int lb)

Sets left bracket position

#### getRb

    public int getRb()

Returns right bracket position, -1 if missing

#### setRb

    public void setRb(int rb)

Sets right bracket position, -1 if not present

#### setParens

    public void setParens(int lb,
                 int rb)

#### toSource

    public java.lang.String toSource(int depth)

Description copied from class: `AstNode`
Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

Specified by:
  `toSource` in class `AstNode`
Parameters:
  `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

#### visit

    public void visit(NodeVisitor v)

Visits this node, the target, and the index expression.

Specified by:
  `visit` in class `AstNode`
Parameters:
  `v` - the object to call with this node and its children